#include <Wire.h> //This line adds the Wire library, which lets your Arduino use a communication system called I2C
#include <LiquidCrystal_I2C.h> //This line adds a library specifically for I2C LCD displays. Gives commands to control the screen.

LiquidCrystal_I2C lcd(0x27,16,2); //This line sets up the LCD screen. It tells the Arduino, “We’re using a screen with address 0x27, 16 columns, and 2 rows"

//Variables for the pins connecting to the LED outputs
int S0 = 3;
int S1 = 4;
int C2 = 5;

//Variables for the pins connecting to the seven-segment display
int a = 9;
int b = 10;
int c = 13;
int d = 12;
int e = 11;
int f = 8;
int g = 7;

//These variables help the Arduino calculate the number you're entering in binary
int sum = 0;
int ones,twos,fours;

void setup() {
  lcd.init();  //initialize the lcd
  lcd.backlight();  //open the backlight 
   for( int i = 7; i<14; i++)
  pinMode (i,OUTPUT); // Tells the Arduino that pins 7 through 13 (for the 7-segment display) are outputs

  //These tell the Arduino that pins 3, 4, and 5 are inputs
  pinMode(S0, INPUT);
  pinMode(S1, INPUT);
  pinMode(C2, INPUT);

  //These pins (named a to g) control each segment of the 7-segment display, setting them up as OUTPUT means Arduino controls whether they are ON or OFF
  pinMode(a, OUTPUT);
  pinMode(b, OUTPUT);
  pinMode(c, OUTPUT);
  pinMode(d, OUTPUT);
  pinMode(e, OUTPUT);
  pinMode(f, OUTPUT);
  pinMode(g, OUTPUT);
  
}
  //Tells Arduino what segment to light up of keep off to display a number 1-6
  void six(){
  digitalWrite (a,LOW);
  digitalWrite (b,HIGH);
  digitalWrite (c,LOW);
  digitalWrite (d,LOW);
  digitalWrite (e,LOW);
  digitalWrite (f,LOW);
  digitalWrite (g,LOW);
  } 

  void five(){
  digitalWrite (a,LOW);
  digitalWrite (b,HIGH);
  digitalWrite (c,LOW);
  digitalWrite (d,LOW);
  digitalWrite (e,HIGH);
  digitalWrite (f,LOW);
  digitalWrite (g,LOW);
  }

  void four(){
  digitalWrite (a,HIGH);
  digitalWrite (b,LOW);
  digitalWrite (c,LOW);
  digitalWrite (d,HIGH);
  digitalWrite (e,HIGH);
  digitalWrite (f,LOW);
  digitalWrite (g,LOW);
  }

  void three(){
  digitalWrite (a,LOW);
  digitalWrite (b,LOW);
  digitalWrite (c,LOW);
  digitalWrite (d,LOW);
  digitalWrite (e,HIGH);
  digitalWrite (f,HIGH);
  digitalWrite (g,LOW);
  }

  void two(){
  digitalWrite (a,LOW);
  digitalWrite (b,LOW);
  digitalWrite (c,HIGH);
  digitalWrite (d,LOW);
  digitalWrite (e,LOW);
  digitalWrite (f,HIGH);
  digitalWrite (g,LOW);
  }

  void one(){
  digitalWrite (a,HIGH);
  digitalWrite (b,LOW);
  digitalWrite (c,LOW);
  digitalWrite (d,HIGH);
  digitalWrite (e,HIGH);
  digitalWrite (f,HIGH);
  digitalWrite (g,HIGH);
  }

  void zero(){
  digitalWrite (a,LOW);
  digitalWrite (b,LOW);
  digitalWrite (c,LOW);
  digitalWrite (d,LOW);
  digitalWrite (e,LOW);
  digitalWrite (f,LOW);
  digitalWrite (g,HIGH);
  }

  void error(){
  digitalWrite (a,HIGH);
  digitalWrite (b,LOW);
  digitalWrite (c,LOW);
  digitalWrite (d,HIGH);
  digitalWrite (e,HIGH);
  digitalWrite (f,HIGH);
  digitalWrite (g,HIGH);
  }
  

void loop() {
  //These lines tell the LCD what to show. First line will show "enter your two #", while the line below wll show "in binary". 
  //Then it will pause for 3 seconds to allow user to read, then clear to get ready to display the result
  lcd.setCursor(0,0);
  lcd.print("enter your two #");
  lcd.setCursor(0,1);
  lcd.print("in binary");
  delay(3000);
  lcd.clear();

 //These lines are used to see whether the inputs are ON (1) or (OFF). If they are ON, it sets its corresponding number (one, two, four)
  if (digitalRead(S0)== 1)
    ones = 1;
  else 
    ones = 0;
  if (digitalRead(S1)== 1)
    twos = 2;
  else
    twos = 0;
  if (digitalRead(C2)== 1)
    fours = 4;
  else
    fours = 0;

 // This line adds up the values of the inputs to find the total number entered in binary.
  sum = fours + twos+ ones;

 //These lines show what will happen based on the value of sum. If sum is 0,first line will show "binary answer is", while the line below wll show "000".
 //Then it will pause for 2 seconds to allow user to read, then clear to get ready to display the next sum 
  if (sum == 0){
  lcd.setCursor(0,0); 
  lcd.print("binary answer is:");
  lcd.setCursor(0,1); 
  lcd.print("000");
  zero();
  delay(2000);
  lcd.clear();
  }
  
  //If sum is not 0, the same idea is repeated for other numbers from 1 to 6, just with different binary values and function calls
  else if (sum == 1){
  lcd.print("binary answer is:");
  lcd.setCursor(0,1); 
  lcd.print("001");
  one();
  delay(2000);
  lcd.clear();
  }
  
  else if (sum == 2){
  lcd.print("binary answer is:");
  lcd.setCursor(0,1); 
  lcd.print("010");
  two();
  delay(2000);
  lcd.clear();
  }
  
  else if (sum == 3){
  lcd.print("binary answer is:");
  lcd.setCursor(0,1); 
  lcd.print("011");
  three();
  delay(2000);
  lcd.clear();
  }
  
  else if (sum == 4){
  lcd.print("binary answer is:");
  lcd.setCursor(0,1); 
  lcd.print("100");
  four();
  delay(2000);
  lcd.clear();
  }
  
  else if (sum == 5){
  lcd.print("binary answer is:");
  lcd.setCursor(0,1); 
  lcd.print("101");
  five();
  delay(2000);
  lcd.clear();
  }
  
  else if (sum == 6){
  lcd.print("binary answer is:");
  lcd.setCursor(0,1); 
  lcd.print("110");
  six();
  delay(2000);
  lcd.clear();
  }
  //If the sum is anything other than 0–6, the Arduino runs error(); and displays "E" on seven-segment
  else 
  error();
 
}
